# AUTOGENERATED! DO NOT EDIT! File to edit: ../../../nbs/dspy/dspy.predict.ccot.ipynb.

# %% auto 0
__all__ = ['log', 'ConciseChainOfThought']

# %% ../../../nbs/dspy/dspy.predict.ccot.ipynb 3
import dspy
from dspy.primitives.program import Module
from dspy.signatures.signature import ensure_signature

from ...logging import get_logger

log = get_logger(__name__)

# %% ../../../nbs/dspy/dspy.predict.ccot.ipynb 4
class ConciseChainOfThought(Module):
    def __init__(self, signature, rationale_type=None, **config):
        super().__init__()

        signature = ensure_signature(signature)

        prefix = "Reasoning: Let's concisely think step by step in order to"
        desc = "${reasoning}"
        rationale_type = rationale_type or dspy.OutputField(prefix=prefix, desc=desc)
        extended_signature = signature.prepend("reasoning", rationale_type, type_=str)
        
        self.predict = dspy.Predict(extended_signature, **config)

    def forward(self, **kwargs):
        return self.predict(**kwargs)

